import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import lejos.nxt.Motor;
import lejos.nxt.comm.Bluetooth;
import lejos.nxt.comm.NXTConnection;
import lejos.robotics.localization.PoseProvider;
import lejos.robotics.navigation.DifferentialPilot;
import lejos.robotics.navigation.Navigator;
import lejos.robotics.navigation.Pose;

public class BTHTestNXT {

	public static void main(String[] args) {
		System.out.println("Attesa connessione Bluetooth...");
		NXTConnection conn = Bluetooth.waitForConnection();
		DataOutputStream dos = conn.openDataOutputStream();
		DataInputStream dis = conn.openDataInputStream();
		System.out.println("Connesso.");

		DifferentialPilot dp = new DifferentialPilot(5.5f, 11.5f, Motor.A, Motor.C);
		PoseProvider pos = new Navigator(dp).getPoseProvider();

		boolean connesso = true;
		while (connesso)
			try {
				dp.setTravelSpeed(dis.readInt() * dp.getMaxTravelSpeed() / 100.0);
				dp.steer(dis.readInt());
				Pose pose = pos.getPose();
				dos.writeDouble(pose.getY());
				dos.writeDouble(pose.getX());
				dos.flush();
			} catch (IOException e) {
				connesso = false;
			}
	}

}
